/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the TemplateGrouped type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateGrouped{}

// TemplateGrouped struct for TemplateGrouped
type TemplateGrouped struct {
	OrganizationId string `json:"organization_id"`
	OrganizationName string `json:"organization_name"`
	GatewayId string `json:"gateway_id"`
	GatewayName *string `json:"gateway_name,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	ChannelName *string `json:"channel_name,omitempty"`
	Name string `json:"name"`
	Category *string `json:"category,omitempty"`
	Type string `json:"type"`
	Templates []TemplateGroupedTemplatesInner `json:"templates"`
	// MIN(created_at) from templates group
	CreatedAt time.Time `json:"created_at"`
	// MAX(updated_at) from templates group
	UpdatedAt time.Time `json:"updated_at"`
}

// NewTemplateGrouped instantiates a new TemplateGrouped object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateGrouped(organizationId string, organizationName string, gatewayId string, name string, type_ string, templates []TemplateGroupedTemplatesInner, createdAt time.Time, updatedAt time.Time) *TemplateGrouped {
	this := TemplateGrouped{}
	this.OrganizationId = organizationId
	this.OrganizationName = organizationName
	this.GatewayId = gatewayId
	this.Name = name
	this.Type = type_
	this.Templates = templates
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewTemplateGroupedWithDefaults instantiates a new TemplateGrouped object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateGroupedWithDefaults() *TemplateGrouped {
	this := TemplateGrouped{}
	return &this
}

// GetOrganizationId returns the OrganizationId field value
func (o *TemplateGrouped) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *TemplateGrouped) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetOrganizationName returns the OrganizationName field value
func (o *TemplateGrouped) GetOrganizationName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationName
}

// GetOrganizationNameOk returns a tuple with the OrganizationName field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetOrganizationNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationName, true
}

// SetOrganizationName sets field value
func (o *TemplateGrouped) SetOrganizationName(v string) {
	o.OrganizationName = v
}

// GetGatewayId returns the GatewayId field value
func (o *TemplateGrouped) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *TemplateGrouped) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetGatewayName returns the GatewayName field value if set, zero value otherwise.
func (o *TemplateGrouped) GetGatewayName() string {
	if o == nil || IsNil(o.GatewayName) {
		var ret string
		return ret
	}
	return *o.GatewayName
}

// GetGatewayNameOk returns a tuple with the GatewayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetGatewayNameOk() (*string, bool) {
	if o == nil || IsNil(o.GatewayName) {
		return nil, false
	}
	return o.GatewayName, true
}

// HasGatewayName returns a boolean if a field has been set.
func (o *TemplateGrouped) HasGatewayName() bool {
	if o != nil && !IsNil(o.GatewayName) {
		return true
	}

	return false
}

// SetGatewayName gets a reference to the given string and assigns it to the GatewayName field.
func (o *TemplateGrouped) SetGatewayName(v string) {
	o.GatewayName = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *TemplateGrouped) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *TemplateGrouped) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *TemplateGrouped) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetChannelName returns the ChannelName field value if set, zero value otherwise.
func (o *TemplateGrouped) GetChannelName() string {
	if o == nil || IsNil(o.ChannelName) {
		var ret string
		return ret
	}
	return *o.ChannelName
}

// GetChannelNameOk returns a tuple with the ChannelName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetChannelNameOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelName) {
		return nil, false
	}
	return o.ChannelName, true
}

// HasChannelName returns a boolean if a field has been set.
func (o *TemplateGrouped) HasChannelName() bool {
	if o != nil && !IsNil(o.ChannelName) {
		return true
	}

	return false
}

// SetChannelName gets a reference to the given string and assigns it to the ChannelName field.
func (o *TemplateGrouped) SetChannelName(v string) {
	o.ChannelName = &v
}

// GetName returns the Name field value
func (o *TemplateGrouped) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *TemplateGrouped) SetName(v string) {
	o.Name = v
}

// GetCategory returns the Category field value if set, zero value otherwise.
func (o *TemplateGrouped) GetCategory() string {
	if o == nil || IsNil(o.Category) {
		var ret string
		return ret
	}
	return *o.Category
}

// GetCategoryOk returns a tuple with the Category field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetCategoryOk() (*string, bool) {
	if o == nil || IsNil(o.Category) {
		return nil, false
	}
	return o.Category, true
}

// HasCategory returns a boolean if a field has been set.
func (o *TemplateGrouped) HasCategory() bool {
	if o != nil && !IsNil(o.Category) {
		return true
	}

	return false
}

// SetCategory gets a reference to the given string and assigns it to the Category field.
func (o *TemplateGrouped) SetCategory(v string) {
	o.Category = &v
}

// GetType returns the Type field value
func (o *TemplateGrouped) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *TemplateGrouped) SetType(v string) {
	o.Type = v
}

// GetTemplates returns the Templates field value
func (o *TemplateGrouped) GetTemplates() []TemplateGroupedTemplatesInner {
	if o == nil {
		var ret []TemplateGroupedTemplatesInner
		return ret
	}

	return o.Templates
}

// GetTemplatesOk returns a tuple with the Templates field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetTemplatesOk() ([]TemplateGroupedTemplatesInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.Templates, true
}

// SetTemplates sets field value
func (o *TemplateGrouped) SetTemplates(v []TemplateGroupedTemplatesInner) {
	o.Templates = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *TemplateGrouped) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *TemplateGrouped) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *TemplateGrouped) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *TemplateGrouped) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *TemplateGrouped) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o TemplateGrouped) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateGrouped) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["organization_name"] = o.OrganizationName
	toSerialize["gateway_id"] = o.GatewayId
	if !IsNil(o.GatewayName) {
		toSerialize["gateway_name"] = o.GatewayName
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.ChannelName) {
		toSerialize["channel_name"] = o.ChannelName
	}
	toSerialize["name"] = o.Name
	if !IsNil(o.Category) {
		toSerialize["category"] = o.Category
	}
	toSerialize["type"] = o.Type
	toSerialize["templates"] = o.Templates
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableTemplateGrouped struct {
	value *TemplateGrouped
	isSet bool
}

func (v NullableTemplateGrouped) Get() *TemplateGrouped {
	return v.value
}

func (v *NullableTemplateGrouped) Set(val *TemplateGrouped) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateGrouped) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateGrouped) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateGrouped(val *TemplateGrouped) *NullableTemplateGrouped {
	return &NullableTemplateGrouped{value: val, isSet: true}
}

func (v NullableTemplateGrouped) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateGrouped) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


